var faviconPicker = {

  init: function()
  {
    window.removeEventListener("load", faviconPicker.init, false);
    var tbrowser = getBrowser();
    tbrowser.faviconPicker_setIcon = tbrowser.setIcon;
    tbrowser.faviconPicker_shouldLoadFavIcon = tbrowser.shouldLoadFavIcon;

    tbrowser.setIcon = faviconPicker.setIcon;
    tbrowser.shouldLoadFavIcon = faviconPicker.shouldLoadFavIcon;
  },

  setIcon: function(aTab, aURI)
  {
    var browser = aTab.linkedBrowser;
    var browser = aTab.linkedBrowser;
    if (!(aURI instanceof Components.interfaces.nsIURI))
      aURI = Services.io.newURI(aURI, null, null);
    var iconURI = "";
    try {
      iconURI = this.mFaviconService.getFaviconForPage(browser.currentURI);
      iconURI = this.mFaviconService.getFaviconImageForPage(browser.currentURI);
    }catch(e){
      if(aURI.spec == "about:/favicon.ico"){
        aURI = null;
      }
    }
    if (iconURI)
      aURI = iconURI;
    this.faviconPicker_setIcon(aTab, aURI);
  },

  shouldLoadFavIcon: function(aURI)
  {
    try {
      aURI = this.mURIFixup.createExposableURI(aURI);
    } catch (e) {
    }
    var rv1 = (aURI && this.mPrefs.getBoolPref("browser.chrome.site_icons") &&
               this.mPrefs.getBoolPref("browser.chrome.favicons") &&
               ("schemeIs" in aURI));
    var rv2 = this.faviconPicker_shouldLoadFavIcon(aURI);
    return rv1 || rv2;
  },

}

window.addEventListener("load", faviconPicker.init, false);
